#include <stdio.h>
#include <stdlib.h>

struct op {
        char nome[50];
        double importo;
        int tipo;
        };
        
struct atomo {
       struct op dato;
       struct atomo *next;
       };
struct coda {
       struct atomo *primo,*ultimo;
       };
       
void leggi(struct op *o);
void in_coda(struct coda *pQ, struct op o);
void out_coda(struct coda *pQ);
void visualizza(struct coda Q);

main() {
       struct coda VQ[3];
       int i,scelta;
       struct op opera;
       
       /* inizializzazione code */
       for(i=0;i<3;i++)
         {VQ[i].primo=NULL;
          VQ[i].ultimo=NULL;
          }
          
       do {
           printf("Scegli tra\n");
           printf("1) In coda\n");
           printf("2) out coda\n");
           printf("3) visualizza coda\n");
           printf("0) fine\n");
           scanf("%d",&scelta);
           switch(scelta) {
           case 1:  leggi(&opera);
                    i=opera.tipo;
                    in_coda(&VQ[i],opera);
                    break;
           case 2:  printf("Coda da servire (0..2) ");
                    scanf("%d",&i);
                    out_coda(&VQ[i]);
                    break;
           case 3:  printf("Coda da visualizzare (0..2) ");
                    scanf("%d",&i);
                    visualizza(VQ[i]);
                    break;
           default:; }
           } while(scelta!=0);
       
       for(i=0;i<3;i++)
         while(VQ[i].primo!=NULL)
         /* fino a quando la coda di indice i 
            non e' vuota */
            out_coda(&VQ[i]);
}
       
void leggi(struct op *o)
{
     printf("Nome: ");
     scanf("%s",o->nome);
     printf("Importo: ");
     scanf("%lf",&o->importo);
     printf("Tipo: (0=raccomandate, 1=Bollettini postali, 2= Servizi finanziari\n");
     scanf("%d",&o->tipo);
}

void in_coda(struct coda *Q, struct op o)
{
     struct atomo *aux;
     
     aux=(struct atomo *) malloc(sizeof(struct atomo));
     if(aux==NULL)
        return;
     aux->dato=o;
     aux->next=NULL;
     
     if(Q->primo==NULL)
       Q->primo=aux;
     else Q->ultimo->next=aux;
     Q->ultimo=aux;
}

void out_coda(struct coda *Q)
{
     struct atomo *aux;
     
     if(Q->primo==NULL)
       { printf("Coda vuota\n");
         return;
       }
     aux=Q->primo;
     Q->primo=aux->next;
     free(aux);
     if(Q->primo==NULL)
        Q->ultimo=NULL;
}

void visualizza(struct coda Q)
{
     struct atomo *l;
     
     l=Q.primo;
     while(l!=NULL)
       { printf("Nome: %s\n",l->dato.nome);
         printf("Importo: %lf\n\n",l->dato.importo);
         l=l->next;
       } 
}      
       
       
       
       
       
